#include <iostream>

using namespace std;

int* board;
int n;

void print_until(int i);

void initialize(){
	board = new int(n);
	for (int i=0; i<n; i++)
		board[i]=-1;
	print_until(n-1);
}

bool valid(int i, int j){
	cout << "checking validtity for (" << i << ", " << j << ")\n";
	for (int col=0; col< i; col++){
		if (board[col]==j)
			return false; // same row
		if (col + board[col] == i+j)
			return false; // diagonal 1
		if (col - board[col] == i - j) 
			return false; // diagonal 2
	}
	return true;
}

// print the board until column i inclusive
void print_until(int i){
	for (int col = 0; col <=i; col++)
		cout << board[col] << " ";
	for (int col = i+1; col < n; col++)
		cout << "-1 ";
	cout << endl;
}

bool solutionExists(int i){ // there is a solution that is consistent with the board so far 
	if (i >=n ) // base case
		return true; // the board is a complete solution.
	for (int j=0; j<n; j++){
		if (valid(i,j)){
			board[i]=j;
			print_until(i);
			if (solutionExists(i+1))
				return true;	
		}
	}
	return false;
}

int main(int argc, char** argv){
	if (argc!=2){
		cout << "Usage: executable.o n" << endl;
		return 1; 
	}

	n = atoi(argv[1]);
	initialize();
	solutionExists(0);
	cout << "The final board is :";
	print_until(n-1);

	delete [] board;

	return 0;
}
